/* Output from p2c, the Pascal-to-C translator */
/* From input file "cht11.p" */

typedef char Char;
typedef short boolean;
#define true 1
#define false 0
#define EXIT_SUCCESS 0
#define P_argc argc
#define P_argv argv
#define strpos2 index
#define strsub strstr
#define Malloc malloc
#include <stdio.h>   
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

typedef struct TPoint {
  long X, Y, C, H, N, O, P, S, Si, Br, Cl, F, I, Na, K, RecCount;
  struct TPoint *Last;
} TPoint;


int main(int argc, char* argv[])
{
  long C, H, N, O, P, S, Si, Br, Cl, F, I, Na, K, X1, X2, Y1, Y2, T;
  FILE *IFile;
  TPoint *Point, *Last, *Current;
  Char sss[256];
  Char A[7];
  double M;
  long Count, atoms, rep;
  boolean Abandon, debug, verbose, exact;
  Char STR1[256], STR2[256];
  long FORLIM;
  Char* TEMP;

  IFile = NULL;
  if (P_argc == 1) {
    printf("enter \"cht -h\" for help\n");
	exit(1);
  }
  C = 0;
  H = 0;
  N = 0;
  O = 0;
  P = 0;
  S = 0;
  Si = 0;
  Br = 0;
  I = 0;
  Cl = 0;
  F = 0;
  Na = 0;
  K = 0;
  verbose = false;
  debug = false;
  exact = false;
  Count = 0;
  for (rep = 1; rep < P_argc; rep++) {
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-v") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--verbose") == 0))
      verbose = true;
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-d") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--debug") == 0))
      debug = true;
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-e") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--exact") == 0))
      exact = true;
    if ((strcmp(strcpy(STR2, P_argv[rep]), "-h") == 0) |
	(strcmp(strcpy(STR1, P_argv[rep]), "--help") == 0)) {
      printf("The Chemtool drawings analyzer 0.11\n");
      printf("***   Gizmo Head Software   ***\n");
      printf("    Radek Liboska (c) 2000\n\n");
      printf("syntax: cht [-options] <filename.cht>\n\n");
      printf("Recognize C,H,O,N,P(V),S(VI),Si,Br,I,Cl,F,Na,K\n");
      printf(
	"          CH,HC,CH_2,H_2C,CH3,H_3C,OH,HO,SH,HS,NH,HN,NH_2,H_2N,CN,CN,N_3,CH_2OH,CH_3O,OCH_3\n");
      printf(
	"          Me,Et,Pr,Bu,iPr,tBu,Ph,Ac,Bz,Bn,Tr,DMTr,Ts,Ms,TMS,TBDMS,TBDPS\n");
      printf(
	"          OMe,OEt,OPr,OBu,OiPr,OtBu,OAc,OBz,OBn,OTr,ODMTr,OTs,OMs,OTMS,OTBDMS,OTBDPS\n");
      printf(
	"          MeO,EtO,PrO,BuO,iPrO,tBuO,AcO,BzO,BnO,TrO,DMTrO,TsO,MsO,TMSO,TBDMSO,TBDPSO\n\n");
      printf("options:\n");
      printf("  -h or --help : this help\n");
      printf("  -e or --exact: calculate exact mass for MS\n");
      printf("  -v or --verbose : be verbose\n");
      printf("  -d or --debug : be more verbose\n\n");
      exit(1);
    }
    if (strcpy(STR2, P_argv[rep])[0] != '-')
	  IFile=fopen(strcpy(STR1, P_argv[rep]),"r");  
  }
  rewind(IFile);
  Point = (TPoint *)Malloc(sizeof(TPoint));
  Point->X = 0;
  Point->Y = 0;
  Point->C = 0;
  Point->H = 0;
  Point->N = 0;
  Point->O = 0;
  Point->P = 0;
  Point->S = 0;
  Point->Si = 0;
  Point->Br = 0;
  Point->Cl = 0;
  Point->F = 0;
  Point->I = 0;
  Point->Na = 0;
  Point->K = 0;
  Point->RecCount = Count;
  Point->Last = NULL;
  /*New(Point);
          Readln(IFile); error herrited from previous versions*/
  fscanf(IFile, "%*[^\n]");
  getc(IFile);
  fscanf(IFile, "%*[^\n]");
  getc(IFile);
  fscanf(IFile, "%*[^\n]");
  getc(IFile);
  fgets(sss, 256, IFile);
  TEMP = strchr(sss, '\n');
  if (TEMP != NULL)
    *TEMP = 0;
  do {
    if (debug)
      puts(sss);

	 sscanf(sss,"%ld %ld %ld %ld %ld",&X1,&Y1,&X2,&Y2,&T);         

    Abandon = false;
    Current = Point;
    while (Point->Last != NULL) {
      if (abs(Point->X-X1)<3 && abs(Point->Y-Y1)<3) {
	if (debug)
	  printf("  %ld --> Joined at %ld %ld\n",
		 Point->RecCount, X1, Y1);
	if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10)
	  Point->H--;
	if (T == 1 || T == 2 || T == 4)
	  Point->H -= 2;
	if (T == 3)
	  Point->H -= 3;
	Abandon = true;
      }
      Point = Point->Last;
    }
    Point = Current;

    if (!Abandon) {
      Count++;
      Last = Point;
      Point = (TPoint *)Malloc(sizeof(TPoint));
      Point->X = X1;
      if (debug)
	printf(" Point^.X: %ld", Point->X);
      Point->Y = Y1;
      if (debug)
	printf(" Point^.Y: %ld", Point->Y);
      Point->C = 1;
      if (debug)
	printf(" Point^.C: %ld", Point->C);
      if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10)
	Point->H = 3;
      if (T == 1 || T == 2 || T == 4)
	Point->H = 2;
      if (T == 3)
	Point->H = 1;
      if (debug)
	printf(" Point^.H: %ld", Point->H);
      Point->N = 0;
      Point->O = 0;
      Point->P = 0;
      Point->S = 0;
      Point->Si = 0;
      Point->Br = 0;
      Point->Cl = 0;
      Point->F = 0;
      Point->I = 0;
      Point->Na = 0;
      Point->K = 0;
      Point->RecCount = Count;
      if (debug)
	printf("Point^.RecCount: %ld\n", Point->RecCount);
      Point->Last = Last;
    }

    Abandon = false;
    Current = Point;
    while (Point->Last != NULL) {
      if (abs(Point->X-X2)<3 && abs(Point->Y-Y2)<3) {
	if (debug)
	  printf("  %ld --> Joined at %ld %ld\n",
		 Point->RecCount, X2, Y2);
	if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10)
	  Point->H--;
	if (T == 1 || T == 2 || T == 4)
	  Point->H -= 2;
	if (T == 3)
	  Point->H -= 3;
	Abandon = true;
      }
      Point = Point->Last;
    }
    Point = Current;

    if (!Abandon) {
      Count++;
      Last = Point;
      Point = (TPoint *)Malloc(sizeof(TPoint));
      Point->X = X2;
      if (debug)
	printf(" Point^.X: %ld", Point->X);
      Point->Y = Y2;
      if (debug)
	printf(" Point^.Y: %ld", Point->Y);
      Point->C = 1;
      if (debug)
	printf(" Point^.C: %ld", Point->C);
      if (T == 0 || T == 5 || T == 6 || T == 7 || T == 10)
	Point->H = 3;
      if (T == 1 || T == 2 || T == 4)
	Point->H = 2;
      if (T == 3)
	Point->H = 1;
      if (debug)
	printf(" Point^.H: %ld", Point->H);
      Point->N = 0;
      Point->O = 0;
      Point->P = 0;
      Point->S = 0;
      Point->Si = 0;
      Point->Br = 0;
      Point->Cl = 0;
      Point->F = 0;
      Point->I = 0;
      Point->Na = 0;
      Point->K = 0;
      Point->RecCount = Count;
      if (debug)
	printf("Point^.RecCount: %ld\n", Point->RecCount);
      Point->Last = Last;
    }

    fgets(sss, 256, IFile);
    TEMP = strchr(sss, '\n');
    if (TEMP != NULL)
      *TEMP = 0;
  } while (isdigit(sss[0]));

  if (debug)
    printf("---- and now parse the labels ---------\n");

    sscanf(sss,"%s %ld",STR2,&atoms);                                            
  if (!strcmp(STR2, "atoms")) {
    if (verbose)
      printf("HeteroAtoms: %ld\n", atoms);
  }
  FORLIM = atoms;
  for (rep = 1; rep <= FORLIM; rep++) {
    fgets(sss, 256, IFile);
    TEMP = strchr(sss, '\n');
    if (TEMP != NULL)
      *TEMP = 0;

	sscanf(sss,"%ld %ld %s",&X1,&Y1,A);   

    if (debug)
      printf("Atom %s X=%ld Y=%ld sss: %s\n", A, X1, Y1, sss);
    Current = Point;
    while (Point->Last != NULL) {
      if (abs(Point->X-X1)<3 && abs(Point->Y-Y1)<3) {
	if (debug)
	  printf("  %ld --> Heteroatom %ld %ld\n",
		 Point->RecCount, X1, Y1);

	if (strcmp(A, "C")) {
	  if (strcmp(A, "CH")) {
	    if (strcmp(A, "HC")) {
	      if (strcmp(A, "CH_2")) {
		if (strcmp(A, "H_2C")) {
		  if (strcmp(A, "CH_3")) {
		    if (strcmp(A, "H_3C")) {
		      if (!strcmp(A, "H")) {
			Point->H -= 2;
			Point->C--;
		      } else if (!strcmp(A, "O")) {
			Point->H -= 2;
			Point->C--;
			Point->O = 1;
		      } else if (!strcmp(A, "OH")) {
			Point->H -= 2;
			Point->C--;
			Point->O = 1;
		      } else if (!strcmp(A, "HO")) {
			Point->H -= 2;
			Point->C--;
			Point->O = 1;
		      } else if (!strcmp(A, "CH_2OH"))
			Point->O++;
		       else if (!strcmp(A, "COOH") || !strcmp(A,"HOOC") 
		      		 || !strcmp(A,"CO_2H") || !strcmp(A,"HO_2C") ){
			Point->O  = 2;
			Point->H -= 2;
			}
		      else if (!strcmp(A, "CH_3O"))
			Point->O++;
		      else if (!strcmp(A, "H_3CO"))
			Point->O++;
		      else if (!strcmp(A, "OCH_3"))
			Point->O++;
		      else if (!strcmp(A, "N")) {
			Point->H--;
			Point->C--;
			Point->N = 1;
		      } else if (!strcmp(A, "NH")) {
			Point->H--;
			Point->C--;
			Point->N = 1;
		      } else if (!strcmp(A, "HN")) {
			Point->H--;
			Point->C--;
			Point->N = 1;
		      } else if (!strcmp(A, "NH_2")) {
			Point->H--;
			Point->C--;
			Point->N = 1;
		      } else if (!strcmp(A, "H_2N")) {
			Point->H--;
			Point->C--;
			Point->N = 1;
		      } else if (!strcmp(A, "NO_2")) {
			Point->H--;
			Point->C--;
			Point->N = 1;
			Point->O = 2;
		      } else if (!strcmp(A, "O_2N")) {
			Point->H--;
			Point->C--;
			Point->N = 1;
			Point->O = 2;
		      } else if (!strcmp(A, "CN")) {
			Point->H -= 3;
			Point->N = 1;
		      } else if (!strcmp(A, "NC")) {
			Point->H -= 3;
			Point->N = 1;
		      } else if (!strcmp(A, "N_3")) {
			Point->H -= 3;
			Point->C--;
			Point->N = 3;
		      } else if (!strcmp(A, "P")) {
			Point->H++;
			Point->C--;
			Point->P = 1;
		      } else if (!strcmp(A, "S")) {
			Point->H += 2;
			Point->C--;
			Point->S = 1;
		      } else if (!strcmp(A, "SH")) {
			Point->H -= 2;
			Point->C--;
			Point->S = 1;
		      } else if (!strcmp(A, "HS")) {
			Point->H -= 2;
			Point->C--;
			Point->S = 1;
		      } else if (!strcmp(A, "Si")) {
			Point->C--;
			Point->Si = 1;
		      } else if (!strcmp(A, "Br")) {
			Point->H -= 3;
			Point->C--;
			Point->Br = 1;
		      } else if (!strcmp(A, "I")) {
			Point->H -= 3;
			Point->C--;
			Point->I = 1;
		      } else if (!strcmp(A, "Cl")) {
			Point->H -= 3;
			Point->C--;
			Point->Cl = 1;
		      } else if (!strcmp(A, "F")) {
			Point->H -= 3;
			Point->C--;
			Point->F = 1;
		      } else if (!strcmp(A, "Na")) {
			Point->H -= 3;
			Point->C--;
			Point->Na = 1;
		      } else if (!strcmp(A, "K")) {
			Point->H -= 3;
			Point->C--;
			Point->K = 1;
		      } else if (!strcmp(A, "Bz")) {
			Point->H += 2;
			Point->C += 6;
			Point->O++;
		      } else if (!strcmp(A, "Ac")) {
			Point->C++;
			Point->O++;
		      } else if (strcmp(A, "Me")) {
			if (!strcmp(A, "Et")) {   /*Ethyl*/
			  Point->H += 2;
			  Point->C++;
			} else if (!strcmp(A, "Pr")) {
			  Point->H += 4;
			  Point->C += 2;
			} else if (!strcmp(A, "Bu")) {
			  Point->H += 6;
			  Point->C += 3;
			} else if (!strcmp(A, "iPr")) {
			  Point->H += 4;
			  Point->C += 2;
			} else if (!strcmp(A, "tBu")) {
			  Point->H += 6;
			  Point->C += 3;
			} else if (!strcmp(A, "Ph")) {
			  Point->H += 2;
			  Point->C += 5;
			} else if (!strcmp(A, "Bn")) {
			  Point->H += 4;
			  Point->C += 6;
			} else if (!strcmp(A, "Tr")) {
			  Point->H += 12;
			  Point->C += 18;
			} else if (!strcmp(A, "DMTr")) {
			  Point->H += 16;
			  Point->C += 20;
			  Point->O += 2;
			} else if (!strcmp(A, "Ts")) {
			  Point->H += 4;
			  Point->C += 6;
			  Point->O += 2;
			  Point->S++;
			} else if (!strcmp(A, "Ms")) {
			  Point->O += 2;
			  Point->S++;
			} else if (!strcmp(A, "TMS")) {
			  Point->H += 6;
			  Point->C += 2;
			  Point->Si++;
			} else if (!strcmp(A, "TBDMS")) {
			  Point->H += 12;
			  Point->C += 5;
			  Point->Si++;
			} else if (!strcmp(A, "TBDPS")) {
			  Point->H += 16;
			  Point->C += 15;
			  Point->Si++;
			} else if (!strcmp(A, "OBz")) {
			  /*O-Benzoyl*/
			  Point->H += 2;
			  Point->C += 6;
			  Point->O += 2;
			} else if (!strcmp(A, "OAc")) {
			  Point->C++;
			  Point->O += 2;
			} else if (!strcmp(A, "OMe"))
			  Point->O++;
			else if (!strcmp(A, "OEt")) {
			  Point->H += 2;
			  Point->C++;
			  Point->O++;
			} else if (!strcmp(A, "OPr")) {
			  Point->H += 4;
			  Point->C += 2;
			  Point->O++;
			} else if (!strcmp(A, "OBu")) {
			  Point->H += 6;
			  Point->C += 3;
			  Point->O++;
			} else if (!strcmp(A, "OiPr")) {
			  Point->H += 4;
			  Point->C += 2;
			  Point->O++;
			} else if (!strcmp(A, "OtBu")) {
			  Point->H += 6;
			  Point->C += 3;
			  Point->O++;
			} else if (!strcmp(A, "OBn")) {
			  Point->H += 4;
			  Point->C += 6;
			  Point->O++;
			} else if (!strcmp(A, "OTr")) {
			  Point->H += 12;
			  Point->C += 18;
			  Point->O++;
			} else if (!strcmp(A, "ODMTr")) {
			  Point->H += 16;
			  Point->C += 20;
			  Point->O += 3;
			} else if (!strcmp(A, "OTs")) {
			  Point->H += 4;
			  Point->C += 6;
			  Point->O += 3;
			  Point->S++;
			} else if (!strcmp(A, "OMs")) {
			  Point->O += 3;
			  Point->S++;
			} else if (!strcmp(A, "OTMS")) {
			  Point->H += 6;
			  Point->C += 2;
			  Point->Si++;
			  Point->O++;
			} else if (!strcmp(A, "OTBDMS")) {
			  Point->H += 12;
			  Point->C += 5;
			  Point->Si++;
			  Point->O++;
			} else if (!strcmp(A, "OTBDPS")) {
			  Point->H += 16;
			  Point->C += 15;
			  Point->Si++;
			  Point->O++;
			} else if (!strcmp(A, "BzO")) {
			  Point->H += 2;
			  Point->C += 6;
			  Point->O += 2;
			} else if (!strcmp(A, "AcO")) {
			  Point->C++;
			  Point->O += 2;
			} else if (!strcmp(A, "MeO"))
			  Point->O++;
			else if (!strcmp(A, "EtO")) {
			  Point->H += 2;
			  Point->C++;
			  Point->O++;
			} else if (!strcmp(A, "PrO")) {
			  Point->H += 4;
			  Point->C += 2;
			  Point->O++;
			} else if (!strcmp(A, "BuO")) {
			  Point->H += 6;
			  Point->C += 3;
			  Point->O++;
			} else if (!strcmp(A, "iPrO")) {
			  Point->H += 4;
			  Point->C += 2;
			  Point->O++;
			} else if (!strcmp(A, "tBuO")) {
			  Point->H += 6;
			  Point->C += 3;
			  Point->O++;
			} else if (!strcmp(A, "BnO")) {
			  Point->H += 4;
			  Point->C += 6;
			  Point->O++;
			} else if (!strcmp(A, "TrO")) {
			  Point->H += 12;
			  Point->C += 18;
			  Point->O++;
			} else if (!strcmp(A, "DMTrO")) {
			  Point->H += 16;
			  Point->C += 20;
			  Point->O += 3;
			} else if (!strcmp(A, "TsO")) {
			  Point->H += 4;
			  Point->C += 6;
			  Point->O += 3;
			  Point->S++;
			} else if (!strcmp(A, "MsO")) {
			  Point->O += 3;
			  Point->S++;
			} else if (!strcmp(A, "TMSO")) {
			  Point->H += 6;
			  Point->C += 2;
			  Point->Si++;
			  Point->O++;
			} else if (!strcmp(A, "TBDMSO")) {
			  Point->H += 12;
			  Point->C += 5;
			  Point->Si++;
			  Point->O++;
			} else if (!strcmp(A, "TBDPSO")) {
			  Point->H += 16;
			  Point->C += 15;
			  Point->Si++;
			  Point->O++;
			} else {
			  printf("Unknown atom %s- execution aborted\n", A);
			  exit(1);
			}
		      }
		    }
		  }
		}
	      }
	    }
	  }
	}
      }
      Point = Point->Last;
    }
    Point = Current;
  }

  if (IFile != NULL)
    fclose(IFile);
  IFile = NULL;
  if (verbose)
    printf("---------------------- Summary -------------------------\n");
  while (Point->Last != NULL) {
    if (verbose)
      printf(
	"RecCount: %ld X=%ld Y=%ld C%ld H%ld N%ld O%ld P%ld S%ld Si%ld Br%ld Cl%ld F%ld I%ld Na%ld K%ld\n",
	Point->RecCount, Point->X, Point->Y, Point->C, Point->H, Point->N,
	Point->O, Point->P, Point->S, Point->Si, Point->Br, Point->Cl,
	Point->F, Point->I, Point->Na, Point->K);
    C += Point->C;
    H += Point->H;
    N += Point->N;
    O += Point->O;
    P += Point->P;
    S += Point->S;
    Si += Point->Si;
    Br += Point->Br;
    Cl += Point->Cl;
    F += Point->F;
    I += Point->I;
    Na += Point->Na;
    K += Point->K;

    Point = Point->Last;
  }
  if (C > 1)
    printf("C%ld", C);
  if (C == 1)
    putchar('C');
  if (H > 1)
    printf("H%ld", H);
  if (H == 1)
    putchar('H');
  if (N > 1)
    printf("N%ld", N);
  if (N == 1)
    putchar('N');
  if (O > 1)
    printf("O%ld", O);
  if (O == 1)
    putchar('O');
  if (P > 1)
    printf("P%ld", P);
  if (P == 1)
    putchar('P');
  if (S > 1)
    printf("S%ld", S);
  if (S == 1)
    putchar('S');
  if (Si > 1)
    printf("Si%ld", Si);
  if (Si == 1)
    printf("Si");
  if (Br > 1)
    printf("Br%ld", Br);
  if (Br == 1)
    printf("Br");
  if (Cl > 1)
    printf("Cl%ld", Cl);
  if (Cl == 1)
    printf("Cl");
  if (F > 1)
    printf("F%ld", F);
  if (F == 1)
    putchar('F');
  if (I > 1)
    printf("I%ld", I);
  if (I == 1)
    putchar('I');
  if (Na > 1)
    printf("Na%ld", Na);
  if (Na == 1)
    printf("Na");
  if (K > 1)
    printf("K%ld", K);
  if (K == 1)
    putchar('K');

  if (exact) {
    M = C * 12 + H * 1.007825037 + N * 14.003074008 + O * 15.99491464 +
	P * 30.9737634 + S * 31.9720718 + Si * 27.9769284 + Br * 78.9183361 +
	Cl * 34.968852729 + F * 18.99840325 + I * 126.904477 +
	Na * 22.9897697 + K * 38.9637079;
    printf(" [%2.10f]\n", M);
  } else {
    M = C * 12.011 + H * 1.0079 + N * 14.0067 + O * 15.9994 + P * 30.9738 +
	S * 32.064 + Si * 28.086 + Br * 79.90 + Cl * 35.453 + F * 18.9984 +
	I * 126.9045 + Na * 22.9898 + K * 39.10;
    printf(" [%2.3f]\n", M);
  }
  if (IFile != NULL)
    fclose(IFile);
  exit(EXIT_SUCCESS);

  /*S(VI)*/
  /*S(II)*/
  /*S(II)*/
  /*Benzoyl*/
  /*Acetyl*/
  /*Methyl*/
  /*Propyl*/
  /*Butyl*/
  /*2-Propyl*/
  /*t-Butyl*/
  /*Phenyl*/
  /*Benzyl*/
  /*Trityl*/
  /*Dimethoxytrityl*/
  /*Tosyl*/
  /*Mesyl*/
  /*Trimethylsilyl*/
  /*Tert-butyldimethylsilyl*/
  /*Tert-butyldiphenylsilyl*/

  /*O-R*/
  /*O-Acetyl*/
  /*O-Methyl*/
  /*O-Ethyl*/
  /*O-Propyl*/
  /*O-Butyl*/
  /*O-2-Propyl*/
  /*O-t-Butyl*/
  /*O-Benzyl*/
  /*O-Trityl*/
  /*O-Dimethoxytrityl*/
  /*O-Tosyl*/
  /*O-Mesyl*/
  /*O-Trimethylsilyl*/
  /*O-Tert-butyldimethylsilyl*/
  /*O-Tert-butyldiphenylsilyl*/
  /*R-O*/
  /*O-Benzoyl*/
  /*O-Acetyl*/
  /*O-Methyl*/
  /*O-Ethyl*/
  /*O-Propyl*/
  /*O-Butyl*/
  /*O-2-Propyl*/
  /*O-t-Butyl*/
  /*O-Benzyl*/
  /*O-Trityl*/
  /*O-Dimethoxytrityl*/
  /*O-Tosyl*/
  /*O-Mesyl*/
  /*O-Trimethylsilyl*/
  /*O-Tert-butyldimethylsilyl*/
  /*O-Tert-butyldiphenylsilyl*/


}




/* End. */
